﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data.Objects;
using System.Linq;
using System.Text;
using System.Web.Mvc;
using Kendo.Mvc;
using Kendo.Mvc.UI;
using Data;
using Models;

namespace Business
{
    public class BusinessLayer
    {
        OTPTESTEntities _repository;

        public BusinessLayer(string connectionString)
        {
            _repository = new OTPTESTEntities(connectionString);
        }

        //public void PopulateMaintenanceResourcesViewData(ViewDataDictionary viewData, string resourceId, string selectedSportId, string yearId)
        //{
        //    var id = 0;

        //    if (!string.IsNullOrEmpty(resourceId))
        //    {
        //        id = int.Parse(resourceId);
        //    }

        //    viewData["genders"] = GetHumanGendersName(true);

        //    string defaultContryId = "CAN";
        //    viewData["defaultCountryId"] = defaultContryId;

        //    var countries = (from c in this._repository.Countries
        //                     select new SelectListItem
        //                     {
        //                         Value = c.CountryID,
        //                         Text =  c.Name_EN,
        //                         Selected = (c.CountryID == defaultContryId)
        //                     }).OrderBy(c => c.Text).ToList();

        //    viewData["countries"] = countries;

        //    //var coachResources = GetCoachResourcesName(null);
        //    //viewData["coachResources"] = coachResources;

        //    viewData["sports"] = (from s in this._repository.Sports
        //                          where s.SportLevelID == Constant.SportLevelId.Sport
        //                          select new SelectListItem
        //                          {
        //                              Value = s.SportID,
        //                              Text = s.Name_EN
        //                          }).OrderBy(c => c.Text).ToList();

        //    viewData["resourceId"] = resourceId;

        //    if (id == 0)
        //    {
        //        viewData["resourceName"] = "Select a resource";
        //    }
        //    else
        //    {
        //        viewData["resourceName"] = (from r in this._repository.Resources
        //                                    where r.ResourceID == id
        //                                    && r.Active
        //                                    select r.FirstName + " " + r.LastName).SingleOrDefault();
        //    }

        //    viewData["YearsList"] = (from y in this._repository.Years
        //                             where y.Active == null || (bool)y.Active
        //                             orderby y.YearID descending
        //                             select new SelectListItem
        //                             {
        //                                 Value = y.YearID,
        //                                 Text = y.YearID
        //                             }).ToList();

        //    //viewData["CurrentYearID"] = GetCurrentYearID();
        //    viewData["CurrentYearID"] = yearId;

        //    var selectedSportLevel = (from s in this._repository.Sports
        //                              where s.SportID == selectedSportId
        //                              select s.SportLevelID).SingleOrDefault();

        //    if (selectedSportLevel == Constant.SportLevelId.Sport)
        //    {
        //        viewData["selectedSport"] = selectedSportId;
        //    }
        //    else if (selectedSportLevel == Constant.SportLevelId.All)
        //    {
        //        viewData["selectedSport"] = (from s in this._repository.Sports
        //                                     where s.SportLevelID == Constant.SportLevelId.Sport
        //                                     && s.Active
        //                                     orderby s.Name_EN
        //                                     select s.SportID).FirstOrDefault();
        //    }

        //    viewData["years"] = (from y in this._repository.Years
        //                         where y.Active == null || (bool)y.Active
        //                         orderby y.YearID
        //                         select new ListItem
        //                         {
        //                             Id = y.YearID,
        //                             Description = y.YearID
        //                         }).ToList();
        //}

        public void PopulateMaintenanceSportsViewData(ViewDataDictionary viewData, string selectedSportId)
        {
            viewData["hpas"] = (from h in this._repository.HPAs
                                orderby h.LastName, h.FirstName
                                select new SelectListItem
                                {
                                    Value = h.HPAID,
                                    Text = h.FirstName + " " + h.LastName
                                }).ToList();

            var nsos = (from o in this._repository.Organizations
                        where o.OrganizationTypeID == Constant.OrganizationTypeId.NSO
                        select new SelectListItem
                        {
                            Value = o.OrganizationID,
                            Text =  o.Name_EN
                        });

            viewData["nsos"] = nsos.OrderBy(o => o.Text).ToList();

            viewData["rankings"] = GetSportRankingsList();

            var sports = (from s in this._repository.Sports
                          where s.SportID == selectedSportId
                          && s.Active
                          select ": " +  s.Name_EN).SingleOrDefault();

            viewData["sportName"] = sports;

            viewData["genders"] = (from g in this._repository.Decodes
                                   where g.DecodeCategoryID == Constant.DecodeCategoryId.Gender
                                   orderby g.SortOrder
                                   select g.DecodeID_EN
                                   ).ToList();

            //viewData["yearId"] = "2013/2014";
            //viewData["selectedSports"] = "S_O_AC_C";

        }

        //public List<MaintenanceAthletesAthleteGridViewModel> GetMaintenanceAthletesAthleteGridViewModel(string selectedSportId, string yearId, Kendo.Mvc.UI.DataSourceRequest request, out int total)
        //{
        //    total = 0;
        //    int sortCount = 0;
        //    int filterCount = 0;

        //    if (string.IsNullOrEmpty(selectedSportId))
        //    {
        //        selectedSportId = Constant.SportId.All;
        //    }

        //    //NOTE: Using "ResourceSports.SportID.StartsWith" to determine sport parent/child relationship is not reliable.
        //    //selectedSportId = Parse3rdLevelSportId(selectedSportId);

        //    Kendo.Mvc.SortDescriptor sort = new Kendo.Mvc.SortDescriptor()
        //    {
        //        Member = "",
        //        SortDirection = ListSortDirection.Ascending
        //    };

        //    if (request.Sorts != null)
        //    {
        //        if (request.Sorts.Any())
        //        {
        //            sort = request.Sorts[0];
        //            sortCount = request.Sorts.Count;
        //        }
        //    }

        //    string filterString = string.Empty;
        //    if (request.Filters != null)
        //    {
        //        filterString = GetFilterString(filterString, request.Filters);
        //        filterCount = request.Filters.Count;
        //    }

        //    ObjectParameter parameter = new ObjectParameter("TotalCount", typeof(int));

        //    if (request.PageSize == 0)
        //    {
        //        request.PageSize = 10;
        //        request.Page = 1;
        //    }

        //    var query = this._repository.uspGetMaintenanceAthleteGridViewModel(
        //                        Constant.LanguageCode.English,
        //                        Constant.ResourceType.Athletes,
        //                        selectedSportId,
        //                        yearId,
        //                        false,
        //                        request.PageSize,
        //                        request.Page,
        //                        sortCount,
        //                        sort.Member,
        //                        sort.SortDirection == ListSortDirection.Ascending ? "ASC" : "DESC",
        //                        filterCount,
        //                        filterString,
        //                        parameter).ToList();

        //    List<MaintenanceAthletesAthleteGridViewModel> model = new List<MaintenanceAthletesAthleteGridViewModel>();

        //    foreach (var item in query)
        //    {
        //        MaintenanceAthletesAthleteGridViewModel modelItem = new MaintenanceAthletesAthleteGridViewModel();

        //        modelItem.LastName = item.LastName;
        //        modelItem.FirstName = item.FirstName;
        //        modelItem.CountryId = item.CountryId;
        //        modelItem.CountryName = item.CountryName;
        //        modelItem.BirthDate = item.BirthDate;
        //        modelItem.GenderId = item.GenderId;
        //        modelItem.GenderName = item.GenderName;
        //        modelItem.ResourceId = item.ResourceId;
        //        modelItem.Pooled = item.Pooled;
        //        modelItem.TBD = item.TBD;
        //        modelItem.IsNew = item.IsNew;
        //        modelItem.BenchmarksEntered = Convert.ToBoolean(item.BenchmarksEntered);
        //        if (item.Category != null)
        //        {
        //            modelItem.Category = item.Category;
        //        }
        //        modelItem.PersonalCoachId = item.PersonalCoachId;
        //        if (item.PersonalCoachName != null)
        //        {
        //            modelItem.PersonalCoachName = item.PersonalCoachName;
        //        }

        //        model.Add(modelItem);
        //    }

        //    total = (int)parameter.Value;

        //    return model;
        //}

        //public MaintenanceAthletesGeneralInfoViewModel GetMaintenanceAthletesGeneralInfoViewModel(int resourceId)
        //{
        //    MaintenanceAthletesGeneralInfoViewModel model = new MaintenanceAthletesGeneralInfoViewModel();

        //    model = (from r in this._repository.Resources
        //            where r.ResourceID == resourceId
        //            select new MaintenanceAthletesGeneralInfoViewModel
        //            {
        //                ResourceId = r.ResourceID,
        //                FirstName = r.FirstName,
        //                LastName = r.LastName,
        //                CountryId = r.CountryID,
        //                Gender = r.Gender,
        //                DateOfBirth = r.DateOfBirth,
        //                PrimaryCSCId = r.PrimaryCSCID,
        //                SecondaryCSCId = r.SecondaryCSCID,
        //                Comments = r.Comments,
        //                TBD = r.TBD,
        //                Pooled = r.Pooled,
        //                Active = r.Active,
        //                IsNew = r.New
        //            }).SingleOrDefault();

        //    if (model != null)
        //    {
        //        //SportID == Constant.SportId.All in ResourceSports is used as Athlete personal coach
        //        model.PersonalCoachId = (from s in this._repository.ResourceSports where s.ResourceID == model.ResourceId && s.SportID == Constant.SportId.All select s.CoachResourceID).FirstOrDefault();

        //        model.Countries = (from c in this._repository.Countries
        //                           select new ListItem
        //                           {
        //                               Id = c.CountryID,
        //                               Description = c.Name_EN
        //                           }).ToList();

        //        model.CSCs = new List<ListItem> { null };
        //        model.CSCs.AddRange((from o in this._repository.Organizations
        //                             where o.OrganizationTypeID == Constant.OrganizationTypeId.CSC
        //                             select new ListItem
        //                             {
        //                                 Id = o.OrganizationID,
        //                                 Description = o.Name_EN
        //                             }).ToList());

        //        model.Genders = GetHumanGenders(true);

        //        var resources = (from r in this._repository.Resources
        //                         join s in this._repository.ResourceSpecialties on r.ResourceSpecialtyID equals s.ResourceSpecialtyID
        //                         where s.CoachIndicator
        //                         select r).ToList();
        //        model.CoachResources = new List<ListItem> { null };
        //        model.CoachResources.AddRange((from r in resources
        //                                       select new ListItem
        //                                       {
        //                                           Id = r.ResourceID.ToString(),
        //                                           Description = r.FirstName + " " + r.LastName + " - " + r.ResourceID.ToString()
        //                                       }).ToList());
        //    }

        //    return model;
        //}

        //public List<MaintenanceAthletesSportsInfoViewModel> GetMaintenanceAthletesSportsInfoViewModel(int resourceId, string yearId)
        //{
        //    List<MaintenanceAthletesSportsInfoViewModel> model = null;

        //    var resource = (from r in this._repository.Resources
        //                    where r.ResourceID == resourceId
        //                    && r.Active
        //                    select r).SingleOrDefault();

        //    if (resource != null)
        //    {
        //        //Constant.SportId.All is used as Athlete personal coach
        //        model = (from s in this._repository.ResourceSports
        //                 where s.ResourceID == resourceId && s.SportID != "ALL"
        //                 //&& s.YearID == yearId
        //                 select new MaintenanceAthletesSportsInfoViewModel
        //                 {
        //                     ResourceId = s.ResourceID,
        //                     ResourceSportId = s.ResourceSportID,
        //                     ResourceClassId = s.ResourceClassID,
        //                     ResourceClassName = (from rl in this._repository.ResourceClasses
        //                                          where rl.ResourceClassID == s.ResourceClassID
        //                                          select rl.Name_EN).FirstOrDefault(),
        //                     SportsId = (from ss in this._repository.Sports
        //                                 where ss.SportID == (from ps in this._repository.Sports
        //                                                      where ps.SportID == s.SportID
        //                                                      select ps.ParentSportID).FirstOrDefault()
        //                                 select ss.ParentSportID).FirstOrDefault(),
        //                     SportName = (from ss in this._repository.Sports
        //                                  where ss.SportID == (from ps in this._repository.Sports
        //                                                       where ps.SportID == (from pps in this._repository.Sports
        //                                                                            where pps.SportID == s.SportID
        //                                                                            select pps.ParentSportID).FirstOrDefault()
        //                                                       select ps.ParentSportID).FirstOrDefault()
        //                                  select ss.Name_EN).FirstOrDefault(),
        //                     DisciplineId = (from ss in this._repository.Sports
        //                                     where ss.SportID == s.SportID
        //                                     select ss.ParentSportID).FirstOrDefault(),
        //                     DisciplineName = (from ss in this._repository.Sports
        //                                       where ss.SportID == (from ps in this._repository.Sports
        //                                                            where ps.SportID == s.SportID
        //                                                            select ps.ParentSportID).FirstOrDefault()
        //                                       select ss.Name_EN).FirstOrDefault(),
        //                     //SportsId = s.Sport.ParentSport.ParentSportID,
        //                     //SportName = s.Sport.ParentSport.ParentSport.Name_EN,
        //                     //DisciplineId = s.Sport.ParentSportID,
        //                     //DisciplineName = s.Sport.ParentSport.Name_EN,
        //                     EventId = s.SportID,
        //                     EventName = (from ss in this._repository.Sports
        //                                  where ss.SportID == s.SportID
        //                                  select ss.Name_EN).FirstOrDefault(),
        //                     //EventName = s.Sport.Name_EN,
        //                     Benchmark = (from b in s.BenchmarkResources
        //                                  where b.Active
        //                                  && b.YearID == yearId
        //                                  select b).Any(),
        //                     YearId = s.YearID,
        //                     HasComments = !string.IsNullOrEmpty(s.Comments),
        //                     SportTrackingRef = s.SportTrackingRef,
        //                     EventCoachId = s.CoachResourceID,
        //                     CoachLastName = (from r in this._repository.Resources
        //                                      where r.ResourceID == s.CoachResourceID
        //                                      select r.LastName).FirstOrDefault(),
        //                     CoachFirstName = (from r in this._repository.Resources
        //                                       where r.ResourceID == s.CoachResourceID
        //                                       select r.FirstName).FirstOrDefault()
        //                 }).OrderByDescending(x => x.YearId).ToList();

        //        foreach (MaintenanceAthletesSportsInfoViewModel item in model)
        //        {
        //            if (item.EventCoachId != null && item.EventCoachId != 0)
        //            {
        //                item.EventCoachName = string.Format("{0} {1} - {2}", item.CoachFirstName, item.CoachLastName, item.EventCoachId);
        //            }
        //        }
        //    }

        //    return model;
        //}

        //public List<MaintenanceAthletesBenchmarkSportsViewModel> GetMaintenanceAthletesBenchmarkSportsViewModel(string year, string resourceSportId)
        //{
        //    var id = 0;

        //    if (!string.IsNullOrEmpty(resourceSportId))
        //    {
        //        id = int.Parse(resourceSportId);
        //    }

        //    List<MaintenanceAthletesBenchmarkSportsViewModel> model = null;

        //    model = (from br in this._repository.BenchmarkResources
        //             where br.ResourceSportID == id
        //             && br.YearID == year
        //             && br.Active
        //             select new MaintenanceAthletesBenchmarkSportsViewModel
        //             {
        //                 Active = br.Active,
        //                 BenchmarkResourceId = br.BenchmarkResourceID,
        //                 BenchmarkTierId = br.BenchmarkTierID,
        //                 BenchmarkTierName = br.BenchmarkTier.Name_EN,
        //                 BenchmarkTypeId = br.BenchmarkTypeID,
        //                 BenchmarkTypeName = br.BenchmarkType.Name_EN,
        //                 HasComments = !string.IsNullOrEmpty(br.Comments),
        //                 NSOValue = br.NSOValue,
        //                 OTPValue = br.OTPValue,
        //                 ResourceSportId = br.ResourceSportID,
        //                 YearId = br.YearID
        //             }).ToList();

        //    return model;
        //}

        public List<MaintenanceSportsGridSportViewModel> GetMaintenanceSportsGridSportViewModel(string year, string selectedSport)
        {
            List<MaintenanceSportsGridSportViewModel> model = null;

            //IEnumerable<string> selectedSportIds = (from a in selectedSports select a.Id);

            model = (from s in this._repository.Sports
                     where s.SportLevelID == Constant.SportLevelId.Sport
                     && s.Active
                     && selectedSport.Contains(s.SportID)
                     let medalEvents = (from discipline in s.ChildSports
                                        where discipline.Active
                                        from sEvent in discipline.ChildSports
                                        where sEvent.Active
                                        && sEvent.MedalEvent != null
                                        && (bool)sEvent.MedalEvent
                                        select sEvent).Any()
                     select new MaintenanceSportsGridSportViewModel
                     {
                         SportId = s.SportID,
                         Name =  s.Name_EN,
                         Gender = s.Gender,
                         HPAID = s.HPAID,
                         HPAName = s.HPA == null ? "none" : s.HPA.FirstName + " " + s.HPA.LastName,
                         NSOID = s.OrganizationID,
                         NSOName = (from o in this._repository.Organizations
                                    where o.OrganizationID == s.OrganizationID
                                    select  o.Name_EN).FirstOrDefault(),
                         Benchmark = s.Benchmark,
                         HasComments = !string.IsNullOrEmpty(s.Comments),
                         SportCode = s.SportCode,
                         SportRankingCategoryID = (from r in s.SportRankings
                                                   where r.YearID == year
                                                   select r.SportRankingCategoryID == "NT" ? "" : r.SportRankingCategoryID).FirstOrDefault(),
                         Ranking = (from r in s.SportRankings
                                    where r.YearID == year
                                    select r.SportRankingCategoryID == "NT" ? "" : r.SportRankingCategoryID).FirstOrDefault(),
                         MedalEvent = medalEvents
                     }).OrderBy(s => s.SportCode).ToList();

            return model;
        }

        public List<MaintenanceSportsGridDisciplineViewModel> GetMaintenanceSportsGridDisciplineViewModel(string parentSportId)
        {
            List<MaintenanceSportsGridDisciplineViewModel> model = null;

            model = (from s in this._repository.Sports
                     where s.ParentSportID == parentSportId
                     && s.Active
                     select new MaintenanceSportsGridDisciplineViewModel
                     {
                         DisciplineId = s.SportID,
                         Name_EN = s.Name_EN,
                         Name_FR = s.Name_FR,
                         Benchmark = s.Benchmark,
                         HasComments = !string.IsNullOrEmpty(s.Comments),
                         SportCode = s.SportCode,
                         Gender = s.Gender,
                         MedalEvent = (from e in s.ChildSports
                                       where e.Active
                                     && e.MedalEvent != null
                                     && (bool)e.MedalEvent
                                       select e).Any()
                     }).ToList();

            return model;
        }

        public List<MaintenanceSportsGridEventViewModel> GetMaintenanceSportsGridEventViewModel(string parentSportId)
        {
            List<MaintenanceSportsGridEventViewModel> model = null;

            model = (from s in this._repository.Sports
                     where s.ParentSportID == parentSportId
                     && s.Active
                     select new MaintenanceSportsGridEventViewModel
                     {
                         EventId = s.SportID,
                         Name_EN = s.Name_EN,
                         Name_FR = s.Name_FR,
                         SportCode = s.SportCode,
                         Benchmark = s.Benchmark,
                         TeamSize = s.TeamSize,
                         HasComments = !string.IsNullOrEmpty(s.Comments),
                         MedalEvent = s.MedalEvent == null ? false : (bool)s.MedalEvent,
                         TeamSport = s.TeamSport == null ? false : (bool)s.TeamSport,
                         ResourceTracking = s.ResourceTracking == null ? false : (bool)s.ResourceTracking
                     }).ToList();

            return model;
        }

        private string GetFilterString(string filterString, IList<Kendo.Mvc.IFilterDescriptor> filters)
        {
            foreach (var ifilter in filters)
            {
                if (ifilter.GetType() == typeof(Kendo.Mvc.CompositeFilterDescriptor))
                {
                    filterString = GetFilterString(filterString, ((Kendo.Mvc.CompositeFilterDescriptor)ifilter).FilterDescriptors);
                }
                else
                {
                    filterString = GetFilterString(filterString, ifilter);
                }
            }

            return filterString;
        }

        private string GetFilterString(string filterString, Kendo.Mvc.IFilterDescriptor iFilter)
        {
            var filter = (Kendo.Mvc.FilterDescriptor)iFilter;

            var filterValue = filter.Value.ToString().ToLower();

            var type = filter.Member.GetType();

            filterString += "Field:" + filter.Member + ","
                          + "Operator:" + filter.Operator.ToString() + ","
                          + "Type:" + type.ToString().Replace("System.", "") + ","
                          + "Content:" + filterValue + "; ";

            return filterString;
        }

        public List<ListItem> GetHumanGenders(bool includeNull)
        {
            List<ListItem> genders = (from g in this._repository.Decodes
                           where g.DecodeCategoryID == Constant.DecodeCategoryId.Gender && (g.DecodeID == Constant.Gender.Male || g.DecodeID == Constant.Gender.Female)
                           orderby g.SortOrder
                           select new ListItem
                           {
                               Id = g.DecodeID,
                               Description = g.DecodeID_EN
                           }).ToList();

            if (includeNull)
            {
                var nullItem = new ListItem { Id = null, Description = "{Not Set}" };
                genders.Insert(0, nullItem);
            }

            return genders;
        }

        public List<string> GetHumanGendersName(bool includeNull)
        {
            List<string> genders = (from g in this._repository.Decodes
                                    where g.DecodeCategoryID == "Gender" && (g.DecodeID == "M" || g.DecodeID == "F")
                                    orderby g.SortOrder
                                    select  g.DecodeID_EN
                                    ).ToList();

            if (includeNull)
            {
                genders.Insert(0, "{Not Set}");
            }

            return genders;
        }

        public string GetCurrentYearID()
        {
            // Year Id is separated by June.
            if (DateTime.Now.Month <= 6)
            {
                return DateTime.Now.AddYears(-1).Year.ToString() + "/" + DateTime.Now.AddYears(0).Year.ToString();
            }
            else
            {
                return DateTime.Now.AddYears(0).Year.ToString() + "/" + DateTime.Now.AddYears(1).Year.ToString();
            }
        }

        public List<SelectListItem> GetSportRankingsList()
        {
            List<SelectListItem> rankings = (from r in this._repository.SportRankingCategories
                                             select new SelectListItem
                                             {
                                                 Value = r.SportRankingCategoryID,
                                                 Text = r.OTPRank + r.OTPRankClass
                                             }).OrderBy(o => o.Text).ToList();

            rankings.Insert(0, new SelectListItem { Value = null, Text = "Select" });

            return rankings;
        }

    }
}
