﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage<Models.MaintenanceAthletesAthleteGridViewModel>" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
    Athletes
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
        <input type="hidden" id="resourceId" value="<%= ViewData["resourceId"] %>" />
        <input type="hidden" id="defaultCountryId" value="<%= ViewData["defaultCountryId"] %>" />
        <input type="hidden" id="CurrentYearID" value="<%= ViewData["CurrentYearID"] %>" />
        <input type="hidden" id="command" value="<%= ViewData["command"] %>" />

    <div>
    <% Html.Kendo().Grid<Models.MaintenanceAthletesAthleteGridViewModel>()
    .Name("Athletes")
        .TableHtmlAttributes(new { style = "font-size:8pt;" })
        .HtmlAttributes(new { style = "height:435px; width:1100px"  })
        .DataSource(dataSource => dataSource
              .Ajax()
              .Model(model => model.Id(a => a.ResourceId))
              .ServerOperation(true)
              .Events(e => e.RequestEnd("onRequestEnd"))
              .Create(create => create.Action("InsertAthlete", "Home"))
              .Read(read => read.Action("AthletesMaintenanceAthleteGridAjax", "Home"))
              .Update(update => update.Action("UpdateAthlete", "Home").Data("onAthleteGridUpdate"))
              .Destroy(destroy => destroy.Action("DeleteAthlete", "Home").Data("onAthleteGridUpdate"))
           )
        .Events(events => events
                        .Save("onAthleteGridSave")
                        .Change("onAthleteGridRowSelect")
                        .DataBound("onRowDataBound")
                        .Edit("onAthleteGridEdit")
                 )
        .Pageable(pager => pager.Input(true)
                                .Refresh(true)
                                .PageSizes(new [] { 10, 20, 30 }) 
                )
        .Scrollable(scrolling => scrolling.Height(285))
        .Sortable()
        .Selectable()
        .Filterable()
        .Resizable(resize => resize.Columns(true))
        .ToolBar(t =>
            {
                t.Create();
            })
        .Editable(e => e.Mode(Kendo.Mvc.UI.GridEditMode.InLine).Enabled(true))
        .Columns(columns =>
        {
            columns.Bound(a => a.ResourceId)
                .Width(50)
                .Filterable(true);
            columns.Bound(a => a.LastName)
                .Width(120);
            columns.Bound(a => a.FirstName)
                .Width(120);
            columns.Bound(a => a.CountryName)
                .Width(130);
            columns.Bound(a => a.GenderName)
                .HeaderHtmlAttributes(new { title = "Gender" })
                .Width(85);
            columns.Bound(a => a.BirthDate)
                .Format("{0:yyyy/MM/dd} ")
                .Width(100)
                .Filterable(true);
            columns.Bound(a => a.Category).Width(90);
            columns.Bound(a => a.PersonalCoachName)
                .HeaderHtmlAttributes(new { title = "Personal Coach Name" })
                .Width(130)
                .Filterable(true)
                .Hidden(false);
            columns.Bound(s => s.AssignSportId)
               .Width(40)
               .Hidden(true);
            columns.Command(a =>
                 {
                         a.Edit();
                         a.Destroy();
                 })
                 .Width(175)
                 .Title("Command");
        }).Render();
                
        %>
        </div>

        <div style="margin:10px 0px 10px 0px; height: 520px">
        <% Html.Kendo().TabStrip()
            .Name("TabStrip")
            .Items(tabstrip =>
            {
                tabstrip.Add()
                    .Text("General")
                    .Selected(true)                  
                    .SpriteCssClasses("sprite sprite-vcard")
                    .Content(() =>
                        {
                          %>
                                <div style="height: 400px">
                                <div class="groupbox_title" >
                                    <%= ViewData["resourceName"] %>
                                </div>
                                </div>
                          <%  
                        });
                tabstrip.Add()
                    .Text("Sports Info")
                    .SpriteCssClasses("sprite sprite-sport_running_man")
                    .Content(() =>
                        {
                          %>
                                <div style="height: 400px">
                                <div class="groupbox_title" >
                                    <%= ViewData["resourceName"] %>
                                </div>
                                </div>
                          <%  
                        });
            })
            .Events(e => e.Select("onTabSelect"))
            .Render();
        %>
        </div>

    <script type="text/javascript">

        var tabstripUrls = ["/Home/AthletesGeneralInfo/", "/Home/AthletesSportsInfo/"];

        function onAthleteGridRowSelect(e) {
            var grid = $("#Athletes").data("kendoGrid");
            var currentRow = grid.dataItem(grid.select());
            var resourceId = currentRow.ResourceId;

            if (resourceId == 0 || resourceId == $('#resourceId').val()) {
                return;
            }

            setAthletesTabData(resourceId);

            var tabstrip = $("#TabStrip").data("kendoTabStrip");
            var index = tabstrip.select().index();
            var tabNumber = index + 1;
            var tabUrl = tabstripUrls[index];

            refreshTab(tabNumber, tabUrl);
        }

        function onRowDataBound(e) {
            // Get the Athletes grid
            var grid = $("#Athletes").data("kendoGrid")._data;

            // Set the resourceID by the 1st row's resourceId
            var resourceId = grid[0]['ResourceId'];

            setAthletesTabData(resourceId);

            // Get the active tab and reload the content of the active tab
            var tabstrip = $("#TabStrip").data("kendoTabStrip");
            var index = tabstrip.select().index();

            var tabNumber = index + 1;
            var tabUrl = tabstripUrls[index];
            refreshTab(tabNumber, tabUrl);
        }

        function setAthletesTabData(id)
        {
            $('#resourceId').val(id);
        }

        function onTabSelect(e)
        {         
            var resourceId = $('#resourceId').val();
            var index = $(e.item).index();
            var tabNumber = index + 1;

            var tabUrl = tabstripUrls[index];
            refreshTab(tabNumber, tabUrl);

        }

        function refreshTab(tabNumber, url)
        {
            var resourceId = $('#resourceId').val();
            var tabResourceId = $("#TabStrip-" + tabNumber).find('#tabResourceId').val();
            
            if(resourceId && resourceId != tabResourceId)
            {
                var tabStrip = $("#TabStrip").data("kendoTabStrip");

                // get the content url for the first tab strip item
                var tabContentUrl = $(tabStrip.element).parent().find(".t-link:eq(" + (tabNumber - 1) + ")").data("ContentUrl");
                if (tabContentUrl)
                {
                    //do nothing
                } 
                else
                {
                    tabContentUrl = url + resourceId;
                }

                // send an ajax request to get the data and post it to the first tab strip item
                $.ajax(
                {
                    type: "POST",
                    url: tabContentUrl,
                    data: { id: resourceId },
                    success: function (data)
                    {
                        //reload the details content tab
                        $("#TabStrip-" + tabNumber).html(data);
                    },
                    complete: function (data)
                    {
                        $('li.tab[tabNumber=' + tabNumber + ']').find('.sprite').removeClass('t-loading'); 
                    }
                });
            }
        }

        function onRequestEnd(e)
        {
            if (e.type == "create" || e.type == "update" || e.type == "destroy") {
                $("#Athletes").data("kendoGrid").dataSource.read();
            }
        }

        function onAthleteGridUpdate(e)
        {
            return { id: e.ResourceId }
        }

        function onAthleteGridEdit(e)
        {
            var coachId = e.model.PersonalCoachId; 
            if (coachId == '0')
            {
                coachId = null;
            }

            var countryId = $("#defaultCountryId").val();
            if (!e.model.isNew())
            {
                countryId = e.model.CountryId;
            }
            else
            {
                var update = $(e.container).parent().find(".k-grid-update");
                $(update).html('<span class="k-icon k-update"></span>Insert');
            }
            
//            var dropdownlist = $("#CountryName").data("kendoDropDownList");
//            dropdownlist.value(countryId);
//            dropdownlist.refresh();            

//            var dropdownlist = $("#PersonalCoachName").data("kendoDropDownList");
//            dropdownlist.value(coachId);
//            dropdownlist.refresh();

        }

        function onAthleteGridSave(e)
        {
            var d = new Date();
            var values = e.model;
            
        }

        function SaveResource(e)
        {
            e.preventDefault();

            $("#AssignSport").data("kendoWindow").open();

            $("#AssignSport").find(".assignsportandsave,.notassignsportandsave")
                .click(function () {
                if ($(this).hasClass("assignsportandsave")) {
                    e.model.AssignSportId = $('#AssignEventId').data('kendoDropDownList').value();
                }
                else if ($(this).hasClass("notassignsportandsave")) {
                    e.model.AssignSportId = "";
                }

                e.sender.saveChanges();
                $("#AssignSport").data("kendoWindow").close();
            })
        }

    </script>

</asp:Content>

<asp:Content ID="Content3" ContentPlaceHolderID="FeaturedContent" runat="server">
</asp:Content>
